--- /dev/null	Sat May 10 12:08:44 2014
+++ new/usr/src/lib/libm/amd64/src/acosl.s	Sat May 10 12:08:44 2014
@@ -0,0 +1,71 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
+ */
+/*
+ * Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+        .file "acosl.s"
+
+#include "libm.h"
+LIBM_ANSI_PRAGMA_WEAK(acosl,function)
+#include "libm_synonyms.h"
+
+#undef fabs
+
+	ENTRY(acosl)
+	fldt	8(%rsp)			/ push x
+	fld1				/ push 1
+	fld	%st(1)			/ x , 1 , x
+	fabs				/ |x| , 1 , x
+	fucomip	%st(1),%st
+	ja	9f
+	fadd	%st(1),%st		/ 1+x,x
+	fldz
+	fucomip	%st(1),%st
+	jp	.L1
+	jne	.L1
+	/ x is -1 
+	fstp	%st(0)			/ -1
+	fstp	%st(0)			/ empty NPX stack
+	fldpi
+	ret
+.L1:
+	fxch	%st(1)			/ x,1+x
+	fld1				/ 1,x,1+x
+	fsubp	%st,%st(1)		/ 1-x,1+x
+	fdivp	%st,%st(1)		/ (1-x)/(1+x)
+	fsqrt
+	fld1				/ 1,sqrt((1-x)/(1+x))
+	fpatan
+	fadd	%st(0),%st
+	ret
+9:
+	/ |x| > 1
+	fstp	%st(0)			/ x
+	fsub	%st,%st(0)		/ +/-0 or NaN+invalid
+	fdiv	%st,%st(0)		/ NaN+invalid or NaN
+	ret
+	.align	16
+	SET_SIZE(acosl)
